#ifndef RATIONAL_H
#define RATIONAL_H

#include <iostream>
#include <sstream>

using namespace std;

long int pgcd(long int a,long int b);

class Rational{
 protected:
  long int p,q;
  void reduce();
public:
  Rational();// create the rational 0
  Rational(long int p);// create the rational p
  Rational(long int p,long int q);// create the rational p/q whenever q>0
  Rational(const Rational& r);
  Rational& operator=(const Rational& r);
  Rational operator+(const Rational& r) const;// return (this + r)
  Rational operator-(const Rational& r) const;// return (this - r)
  Rational operator-() const;// return (- this)
  Rational operator*(const Rational& r) const;// return (this * r)
  Rational operator/(const Rational& r) const;// return (this / r) whenever r!=0
  bool operator==(const Rational& r) const;// test if (this == r)
  bool operator!=(const Rational& r) const;// test if (this != r)
  bool operator<(const Rational& r) const;// test if (this < r)
  bool operator>(const Rational& r) const;// test if (this > r)
  bool operator<=(const Rational& r) const;// test if (this <= r)
  bool operator>=(const Rational& r) const;// teste if (this >= r)
  friend Rational operator+(const long int& a,const Rational& r);
  friend Rational operator-(const long int& a,const Rational& r);
  friend Rational operator*(const long int& a,const Rational& r);
  friend Rational operator/(const long int& a,const Rational& r);
  friend bool operator==(const long int& a,const Rational& r);
  friend bool operator!=(const long int& a,const Rational& r);
  friend bool operator<(const long int& a,const Rational& r);
  friend bool operator>(const long int& a,const Rational& r);
  friend bool operator<=(const long int& a,const Rational& r);
  friend bool operator>=(const long int& a,const Rational& r);
  friend ostream& operator<<(ostream& os,const Rational& r);
};




#endif
